;        8  2006.
;(       ) 
; 4   4  
; _0-3   
; _4-7    
; _0   
;--------------------------------------------------------------------
; PIC16F628
		include<p16f628.inc>
		__CONFIG	B'11111100100001';osc xt, wdog timer off,  power-up timer on,
;--------------------------------------------------------------------
; PIC16F84
;		include<p16f84.inc>
;		__CONFIG	B'11111111111001';osc xt, wdog timer off,  power-up timer off,
;--------------------------------------------------------------------


;constants
WOLUM_T	equ		D'63'	; D'63', H'3F',max number in comand
NAMB_B	equ		6		; number bit in comand
TANGASH	equ		0		; chanel tangash
KREN	equ		1		; chanel kren
GAZ		equ		2		; chanel gaz	
D_BIT	equ		83		; time sent bit
;variabls
TIME_T	equ		H'21'	; time tangash
TIME_K	equ		H'22'	; time kren
TIME_G	equ		H'23'	; time gaz
TIME_W	equ		H'24'	; time 
DISCR	equ		H'25'	; discret comand
COUNTER	equ		H'26'	; counter for measurements or sent bit  ;     
COUNT	equ		H'27'	; counter for macro


;macros delay
DLAY	macro	CIKL	; (1-254)
		local	loop
		movlw	CIKL
		movwf	COUNT
loop	decfsz	COUNT,F
		goto	loop	
		endm			; _______delay=cikl*3T

;programa____________________
		org		H'0'
RESET	goto	START
		org		H'4'
;--------------------------------------------------------------------
START
		bsf		STATUS,RP0	;portB0,B1,B2,  port A0 output, resistor off
		movlw	B'11110000'	;0-2_,3-7_
		movwf	TRISB
		movlw	B'11111110'	;port A0 output
		movwf	TRISA
		movlw	B'11111110'	;resistor off
		movwf	OPTION_REG	
		bcf		STATUS,RP0	;bank 0
		nop
;--------------------------------------------------------------------
;     PIC16F84
		MOVLW   0x07
		MOVWF   CMCON			; CMCON- 
;--------------------------------------------------------------------
		movlw	B'00001111'	;1 sent in port B0,B1,B2,B3 and port A0
		movwf	PORTB 		; 1   0-3
		movlw	B'00000001'	;1 sent in port A0
;--------------------------------------------------------------------
; 
		movwf	PORTA		; 1   0
		DLAY	D'255'		;charge capacity (2,3mc)____500T  2,3ms
		DLAY	D'255'
		DLAY	D'251'
		bcf		STATUS,RP0	
		nop
		clrf	PORTA
;		movfw	B'00000000'	;0 sent in port A0; 0   0
;		movwf	PORTA		; 0=0
		bsf		STATUS,RP0	;portB resiv
		nop
		movlw	B'11111111'
		movwf	TRISB		;portB  
		bcf		STATUS,RP0	

;--------------------------------------------------------------------
;   
		movlw	WOLUM_T		;install namber of the count  ;D'63', H'3F',max number in comand
		movwf	COUNTER		;   63(     )
		clrf	TIME_T		; time tangash
		clrf	TIME_K		; time kren
		clrf	TIME_G		; time gaz
		clrf	TIME_W		; time 
LOOP_1	btfsc	PORTB,0		;    ,
		incf	TIME_T,f 	; .   
		btfsc	PORTB,1		;    
		incf	TIME_K,f 	; .   
		btfsc	PORTB,2		;    
		incf	TIME_G,f 	; .   

		btfsc	PORTB,3		;measurement      
		incf	TIME_W,f 	; .   

		DLAY	D'4'		; 12
		decfsz	COUNTER,f	;if counter=0 then exit    f
		goto	LOOP_1		;       .

;    
;--------------------------------------------------------------------

		DLAY	D'238'		; 714 
;  
		movlw	B'00000001'	;sent START bit in port A0
		movwf	PORTA		; 0=1
		nop
		DLAY	D'132'		; 396 
		movlw	B'00000000'
		movwf	PORTA;		; 0=0
		nop	
		DLAY	D'131'		; 393 
;  
;--------------------------------------------------------------------
;    
		movlw	6
		movwf	COUNTER		;=6
loop_2	movf	TIME_T,W	;cikl sent tangach
		movwf	PORTA
		nop
		nop	
		nop	
		DLAY	D_BIT		; 250  D_BIT=83
		movf	TIME_T,W
		xorlw	B'00000001'	;       W		
		movwf	PORTA
		DLAY	D_BIT		; 250 
		rrf		TIME_T,f	;     
		decfsz	COUNTER,f
		goto	loop_2
;    
;--------------------------------------------------------------------
;    
		movlw	6
		movwf	COUNTER
loop_3	movf	TIME_K,W	;cikl sent kren
		movwf	PORTA
		nop
		nop
		nop
		DLAY	D_BIT		; 250 
		movf	TIME_K,W
		xorlw	B'00000001'	;       W
		movwf	PORTA
		DLAY	D_BIT		; 250 
		rrf		TIME_K,f	;     
		decfsz	COUNTER,f
		goto	loop_3

;    
;--------------------------------------------------------------------
;    
		movlw	6
		movwf	COUNTER
loop_4	movf	TIME_G,W	;cikl sent gaz
		movwf	PORTA
		nop
		nop
		nop
		DLAY	D_BIT		; 250 
		movf	TIME_G,W
		xorlw	B'00000001'	;       W
		movwf	PORTA
		DLAY	D_BIT		; 250 
		rrf		TIME_G,f	;     
		decfsz	COUNTER,f
		goto	loop_4
;    
;--------------------------------------------------------------------

;    
		movlw	6
		movwf	COUNTER
loop_9	movf	TIME_W,W	;cikl sent gaz
		movwf	PORTA
		nop
		nop
		nop
		DLAY	D_BIT		; 250 
		movf	TIME_W,W
		xorlw	B'00000001'	;       W
		movwf	PORTA
		DLAY	D_BIT		; 250 
		rrf		TIME_W,f	;     
		decfsz	COUNTER,f
		goto	loop_9
;    
;--------------------------------------------------------------------

;    
		movf	PORTB,W		;    
		movwf	DISCR		;   DISCR
		rrf		DISCR, F		;  DISCR
		rrf		DISCR, F		;  DISCR
		rrf		DISCR, F		;  DISCR
		rrf		DISCR, F		;  DISCR
;    
		movlw	4
		movwf	COUNTER
loop_5	movf	DISCR,W 	;cikl sent gaz
;		andlw	B'00000001'
		movwf	PORTA
		nop
		nop
		nop
		DLAY	D_BIT		; 250 
		movf	DISCR,W
		xorlw	B'00000001'	;       W			
		movwf	PORTA
		DLAY	D_BIT		; 250 
		rrf		DISCR,f
		decfsz	COUNTER,f
		goto	loop_5
		goto	START

;--------------------------------------------------------------------

		end
