
		include<p16f628.inc>
;		include<p16f84.inc>
		__CONFIG	B'11111100100001';osc xt, wdog timer off,  power-up timer on,
;constants
;NAMB_B	equ		6	;number bit in comand
;TANGASH	equ		0	;chanel tangash
;KREN	equ		1	;chanel kren
;GAZ		equ		2	;chanel gaz	
;variabls
TIME_T	equ		H'21'	; time tangash
TIME_K	equ		H'22'	; time kren
TIME_G	equ		H'23'	; time gaz
TIME_W	equ		H'24'	; time 
DISCR	equ		H'25'	;discret comand
COUNTER	equ		H'26'	;counter for read data
COUNT	equ		H'27'	;counter for dlay
BUFER	equ		H'28'	;bufer for data
BUFER_C	equ		H'29'	;bufer for control
ACCUM	equ		H'2A'	;accumul for data
DLAY_P	equ		H'2B'	;delay from preruvanie

;macros delay
DLAY	macro	CIKL	;(1-254);delay=cikl*3T
		local	loop
		movlw	CIKL
		movwf	COUNT
loop	decfsz	COUNT,F
		goto	loop	
		endm
;macros read data	
READ_D	macro	TIME
		local	LOOP
LOOP	DLAY	D'128'		;read data  0.384 
		nop		
		nop
		rrf		ACCUM,F		;roll to rite      
 		movf	PORTA,W		;    
		movwf	BUFER		;save data in bufer
		nop
		DLAY	D'132'		;  0.396 
		comf	PORTA,W		;control data    f
		xorwf	BUFER,W		;     W  f
		movwf	BUFER_C
		btfsc	BUFER_C,4	;    ,  .   .
		goto	S_PAUZA
		btfsc	BUFER,4		;write bit     ,  .   .
		bsf		ACCUM,5
		btfss	BUFER,4		;    1,  .   .
		bcf		ACCUM,5
		decfsz	COUNTER		;   f,       .
		goto	LOOP
		endm
;programa____________________
		org		H'0'
RESET	goto	START
		org		H'4'
START
		bsf		STATUS,RP0	;portB0-B7 output port A4 input, resistor off
		movlw	B'00000000'	;port B0-B5 OUTPUT
		movwf	TRISB
		movlw	B'11111111'	;port A0 input
		movwf	TRISA
		movlw	B'11111111'	;resistor off
		movwf	OPTION_REG	
		bcf		STATUS,RP0
		clrf	PORTB		;  
		MOVLW   0x07
		MOVWF   CMCON			; CMCON- 

;		goto 	OUTPUT	

;--------------------------------------------------------------------

S_PAUZA	movlw	D'145'		;_________select sinhropauza
		movwf	COUNTER
READ_0	DLAY	2			;delay 6 mks
		btfsc	PORTA,4		;celekt 0     ,  .   .
		goto	S_PAUZA
		decfsz	COUNTER,F	;   f,       .
		goto	READ_0

;--------------------------------------------------------------------

READ_1	btfss	PORTA,4		;________select start bit     1,  .   .
		goto	READ_1
		DLAY	42			;delay 198 mks;
		btfss	PORTA,4		;read 1     1,  .   .
		goto	S_PAUZA
		nop
		DLAY	84			;delay 396 mks
		btfsc	PORTA,4		;read0
		goto	S_PAUZA

;--------------------------------------------------------------------

		movlw	6			;______________resiv tangash
		movwf	COUNTER
		nop
		DLAY	2
	READ_D	TIME_T
		movf	ACCUM,W		;write data
		andlw	B'00111111'
		movwf	TIME_T
;--------------------------------------------------------------------
		movlw	6			;______________resiv KREN
		movwf	COUNTER
	READ_D	TIME_K
		movf	ACCUM,W		;write data
		andlw	B'00111111'
		movwf	TIME_K
;--------------------------------------------------------------------
		movlw	6			;______________resiv gaz
		movwf	COUNTER
	READ_D	TIME_G
		movf	ACCUM,W		;write data
		andlw	B'00111111'
		movwf	TIME_G


;--------------------------------------------------------------------
		movlw	6			;______________resiv 
		movwf	COUNTER
	READ_D	TIME_W
		movf	ACCUM,W		;write data
		andlw	B'00111111'
		movwf	TIME_W

;--------------------------------------------------------------------
		movlw	4			;______________resiv discr
		movwf	COUNTER
	READ_D	DISCR
		rlf		ACCUM,F		;roll to rite      
		rlf		ACCUM,F		;roll to rite      
		movf	ACCUM,W		;write data
		andlw	B'11110000'	;detect discr   ""    W
OUTPUT	addlw	B'00001111'	;add analog chanel	   W	
		movwf	PORTB		;sent 1 in port
;		nop
		DLAY	D'255'		;1000 mks   
		DLAY	D'72'

;    (  = 0  +1)

		movf	TIME_T,W	;add 1 if time_t=0  TIME_T
		addlw	0			;   W
		btfsc	STATUS,Z	;    ,  .   .
		addlw	1			;   W
		movwf	TIME_T


		movf	TIME_K,W	;add 1 if time_k=0 
		addlw	0			;   W
		btfsc	STATUS,Z	;    ,  .   .
		addlw	1			;   W
		movwf	TIME_K


		movf	TIME_G,W	;add 1 if time_g=0 
		addlw	0			;   W
		btfsc	STATUS,Z	;    ,  .   .
		addlw	1			;   W
		movwf	TIME_G


		movf	TIME_W,W	;add 1 if time_g=0 
		addlw	0			;   W
		btfsc	STATUS,Z	;    ,  .   .
		addlw	1			;   W
		movwf	TIME_W

;--------------------------------------------------------------------
		movlw	D'63'
		movwf	COUNTER
TANGASH 	;nop
;		nop
;		nop
;		nop


		decfsz	TIME_T		;   f,       .
		goto	KREN
		bcf		PORTB,0


KREN	decfsz	TIME_K		;   f,       .
		goto	DISKR
		bcf		PORTB,1


DISKR	decfsz	TIME_G		;   f,       .
		goto	WYSOTA
		bcf		PORTB,2


WYSOTA	decfsz	TIME_W		;   f,       .
		goto	OVER
		bcf		PORTB,3

OVER	decfsz	COUNTER
		goto	TANGASH
		bcf		PORTB,0
		bcf		PORTB,1
		bcf		PORTB,2
		bcf		PORTB,3
		goto	S_PAUZA
;		nop
		END
